<?php
/**
 * User: dev
 * Date: 3/11/14
 * Time: 8:58 AM
 */

namespace Blackjack\Objects;


class Request {
    private $_parameterToUriPartMapping = array(
        'sessionId',
        'command'
    );

    private $_uriParts = array(
        'sessionId'     => 'login',
        'command'       => 'login'
    );

    function __construct($request='')
    {
        $request = urldecode($request);
        if ('' == $request)
        {
            $request = $_SERVER['REQUEST_URI'];
        }

        $uriParts = explode('/', $request);

        for($i=0; $i<count($this->_parameterToUriPartMapping); $i++)
        {
            $this->_uriParts[$this->_parameterToUriPartMapping[$i]] = $uriParts[$i];
        }
    }

    function __get($key)
    {
        if (!array_key_exists($key, $this->_uriParts))
        {
            return null;
        }

        return $this->_uriParts[$key];
    }



}